Colt 1.2.0

## cern.colt.matrix
Class DoubleMatrix1D

    java.lang.Object
      cern.colt.PersistentObject
          cern.colt.matrix.impl.AbstractMatrix
              cern.colt.matrix.impl.AbstractMatrix1D
                  cern.colt.matrix.DoubleMatrix1D

All Implemented Interfaces:
  Serializable, Cloneable

Direct Known Subclasses:
  DenseDoubleMatrix1D, SparseDoubleMatrix1D

    public abstract class DoubleMatrix1D

extends AbstractMatrix1D

Abstract base class for 1-d matrices (aka vectors) holding `double` elements. First see the package summary and javadoc tree view to get the broad picture.

A matrix has a number of cells (its size), which are assigned upon instance construction. Elements are accessed via zero based indexes. Legal indexes are of the form `[0..size()-1]`. Any attempt to access an element at a coordinate `index<0 || index>=size()` will throw an `IndexOutOfBoundsException`.

Version:
  1.0, 09/24/99
See Also:
  Serialized Form

Field Summary

Fields inherited from class cern.colt.PersistentObject
`serialVersionUID`

Method Summary
`double` `aggregate(DoubleDoubleFunction aggr, DoubleFunction f)` Applies a function to each cell and aggregates the results.
`double` `aggregate(DoubleMatrix1D other, DoubleDoubleFunction aggr, DoubleDoubleFunction f)` Applies a function to each corresponding cell of two matrices and aggregates the results.
`DoubleMatrix1D` `assign(double value)` Sets all cells to the state specified by `value`.
`DoubleMatrix1D` `assign(double[] values)` Sets all cells to the state specified by `values`.
`DoubleMatrix1D` `assign(DoubleFunction function)` Assigns the result of a function to each cell; `x[i] = function(x[i])`.
`DoubleMatrix1D` `assign(DoubleMatrix1D other)` Replaces all cell values of the receiver with the values of another matrix.
`DoubleMatrix1D` `assign(DoubleMatrix1D y, DoubleDoubleFunction function)` Assigns the result of a function to each cell; `x[i] = function(x[i],y[i])`.
`DoubleMatrix1D` `assign(DoubleMatrix1D y, DoubleDoubleFunction function, IntArrayList nonZeroIndexes)` Assigns the result of a function to each cell; `x[i] = function(x[i],y[i])`.
`int` `cardinality()` Returns the number of cells having non-zero values; ignores tolerance.
`DoubleMatrix1D` `copy()` Constructs and returns a deep copy of the receiver.
`boolean` `equals(double value)` Returns whether all cells are equal to the given value.
`boolean` `equals(Object obj)` Compares this object against the specified object.
`double` `get(int index)` Returns the matrix cell value at coordinate `index`.
`void` `getNonZeros(IntArrayList indexList, DoubleArrayList valueList)` Fills the coordinates and values of cells having non-zero values into the specified lists.
`void` `getNonZeros(IntArrayList indexList, DoubleArrayList valueList, int maxCardinality)` Fills the coordinates and values of cells having non-zero values into the specified lists.
`abstract double` `getQuick(int index)` Returns the matrix cell value at coordinate `index`.
`DoubleMatrix1D` `like()` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the same size.
`abstract DoubleMatrix1D` `like(int size)` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified size.
`abstract DoubleMatrix2D` `like2D(int rows, int columns)` Construct and returns a new 2-d matrix of the corresponding dynamic type, entirelly independent of the receiver.
`void` `set(int index, double value)` Sets the matrix cell at coordinate `index` to the specified value.
`abstract void` `setQuick(int index, double value)` Sets the matrix cell at coordinate `index` to the specified value.
`void` `swap(DoubleMatrix1D other)` Swaps each element `this[i]` with `other[i]`.
`double[]` `toArray()` Constructs and returns a 1-dimensional array containing the cell values.
`void` `toArray(double[] values)` Fills the cell values into the specified 1-dimensional array.
`String` `toString()` Returns a string representation using default formatting.
`DoubleMatrix1D` `viewFlip()` Constructs and returns a new flip view.
`DoubleMatrix1D` `viewPart(int index, int width)` Constructs and returns a new sub-range view that is a `width` sub matrix starting at `index`.
`DoubleMatrix1D` `viewSelection(DoubleProcedure condition)` Constructs and returns a new selection view that is a matrix holding the cells matching the given condition.
`DoubleMatrix1D` `viewSelection(int[] indexes)` Constructs and returns a new selection view that is a matrix holding the indicated cells.
`DoubleMatrix1D` `viewSorted()` Sorts the vector into ascending order, according to the natural ordering.
`DoubleMatrix1D` `viewStrides(int stride)` Constructs and returns a new stride view which is a sub matrix consisting of every i-th cell.
`double` `zDotProduct(DoubleMatrix1D y)` Returns the dot product of two vectors x and y, which is `Sum(x[i]*y[i])`.
`double` `zDotProduct(DoubleMatrix1D y, int from, int length)` Returns the dot product of two vectors x and y, which is `Sum(x[i]*y[i])`.
`double` `zDotProduct(DoubleMatrix1D y, int from, int length, IntArrayList nonZeroIndexes)` Returns the dot product of two vectors x and y, which is `Sum(x[i]*y[i])`.
`double` `zSum()` Returns the sum of all cells; `Sum( x[i] )`.

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix1D
`checkSize, size, toStringShort`

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix
`ensureCapacity, trimToSize`

Methods inherited from class cern.colt.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### aggregate

    public double aggregate(DoubleDoubleFunction aggr,
                            DoubleFunction f)

  Applies a function to each cell and aggregates the results. Returns a value `v` such that `v==a(size())` where `a(i) == aggr( a(i-1), f(get(i)) )` and terminators are `a(1) == f(get(0)), a(0)==Double.NaN`.

  Example:

      cern.jet.math.Functions F = cern.jet.math.Functions.functions;
      matrix = 0 1 2 3

      // Sum( x[i]*x[i] )
      matrix.aggregate(F.plus,F.square);
      --> 14

  For further examples, see the package doc.

  Parameters:
    `aggr` - an aggregation function taking as first argument the current aggregation and as second argument the transformed current cell value.
    `f` - a function transforming the current cell value.
  Returns:
    the aggregated measure.
  See Also:
    `Functions`

### aggregate

    public double aggregate(DoubleMatrix1D other,
                            DoubleDoubleFunction aggr,
                            DoubleDoubleFunction f)

  Applies a function to each corresponding cell of two matrices and aggregates the results. Returns a value `v` such that `v==a(size())` where `a(i) == aggr( a(i-1), f(get(i),other.get(i)) )` and terminators are `a(1) == f(get(0),other.get(0)), a(0)==Double.NaN`.

  Example:

      cern.jet.math.Functions F = cern.jet.math.Functions.functions;
      x = 0 1 2 3
      y = 0 1 2 3

      // Sum( x[i]*y[i] )
      x.aggregate(y, F.plus, F.mult);
      --> 14

      // Sum( (x[i]+y[i])^2 )
      x.aggregate(y, F.plus, F.chain(F.square,F.plus));
      --> 56

  For further examples, see the package doc.

  Parameters:
    `aggr` - an aggregation function taking as first argument the current aggregation and as second argument the transformed current cell values.
    `f` - a function transforming the current cell values.
  Returns:
    the aggregated measure.
  Throws:
    `IllegalArgumentException` - if `size() != other.size()`.
  See Also:
    `Functions`

### assign

    public DoubleMatrix1D assign(double[] values)

  Sets all cells to the state specified by `values`. `values` is required to have the same number of cells as the receiver.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

  Parameters:
    `values` - the values to be filled into the cells.
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `values.length != size()`.

### assign

    public DoubleMatrix1D assign(double value)

  Sets all cells to the state specified by `value`.

  Parameters:
    `value` - the value to be filled into the cells.
  Returns:
    `this` (for convenience only).

### assign

    public DoubleMatrix1D assign(DoubleFunction function)

  Assigns the result of a function to each cell; `x[i] = function(x[i])`. (Iterates downwards from `[size()-1]` to `[0]`).

  Example:

      // change each cell to its sine
      matrix =   0.5      1.5      2.5       3.5
      matrix.assign(cern.jet.math.Functions.sin);
      -->
      matrix ==  0.479426 0.997495 0.598472 -0.350783

  For further examples, see the package doc.

  Parameters:
    `function` - a function object taking as argument the current cell's value.
  Returns:
    `this` (for convenience only).
  See Also:
    `Functions`

### assign

    public DoubleMatrix1D assign(DoubleMatrix1D other)

  Replaces all cell values of the receiver with the values of another matrix. Both matrices must have the same size. If both matrices share the same cells (as is the case if they are views derived from the same matrix) and intersect in an ambiguous way, then replaces as if using an intermediate auxiliary deep copy of `other`.

  Parameters:
    `other` - the source matrix to copy from (may be identical to the receiver).
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `size() != other.size()`.

### assign

    public DoubleMatrix1D assign(DoubleMatrix1D y,
                                 DoubleDoubleFunction function)

  Assigns the result of a function to each cell; `x[i] = function(x[i],y[i])`.

  Example:

      // assign x[i] = x[i]y[i]
      m1 = 0 1 2 3;
      m2 = 0 2 4 6;
      m1.assign(m2, cern.jet.math.Functions.pow);
      -->
      m1 == 1 1 16 729

  For further examples, see the package doc.

  Parameters:
    `y` - the secondary matrix to operate on.
    `function` - a function object taking as first argument the current cell's value of `this`, and as second argument the current cell's value of `y`,
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `size() != y.size()`.
  See Also:
    `Functions`

### assign

    public DoubleMatrix1D assign(DoubleMatrix1D y,
                                 DoubleDoubleFunction function,
                                 IntArrayList nonZeroIndexes)

  Assigns the result of a function to each cell; `x[i] = function(x[i],y[i])`. (Iterates downwards from `[size()-1]` to `[0]`).

  Example:

      // assign x[i] = x[i]y[i]
      m1 = 0 1 2 3;
      m2 = 0 2 4 6;
      m1.assign(m2, cern.jet.math.Functions.pow);
      -->
      m1 == 1 1 16 729

      // for non-standard functions there is no shortcut:
      m1.assign(m2,
         new DoubleDoubleFunction() {
            public double apply(double x, double y) { return Math.pow(x,y); }
         }
      );

  For further examples, see the package doc.

  Parameters:
    `y` - the secondary matrix to operate on.
    `function` - a function object taking as first argument the current cell's value of `this`, and as second argument the current cell's value of `y`,
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `size() != y.size()`.
  See Also:
    `Functions`

### cardinality

    public int cardinality()

  Returns the number of cells having non-zero values; ignores tolerance.

### copy

    public DoubleMatrix1D copy()

  Constructs and returns a deep copy of the receiver.

  Note that the returned matrix is an independent deep copy. The returned matrix is not backed by this matrix, so changes in the returned matrix are not reflected in this matrix, and vice-versa.

  Returns:
    a deep copy of the receiver.

### equals

    public boolean equals(double value)

  Returns whether all cells are equal to the given value.

  Parameters:
    `value` - the value to test against.
  Returns:
    `true` if all cells are equal to the given value, `false` otherwise.

### equals

    public boolean equals(Object obj)

  Compares this object against the specified object. The result is `true` if and only if the argument is not `null` and is at least a `DoubleMatrix1D` object that has the same sizes as the receiver and has exactly the same values at the same indexes.

  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the object to compare with.
  Returns:
    `true` if the objects are the same; `false` otherwise.

### get

    public double get(int index)

  Returns the matrix cell value at coordinate `index`.

  Parameters:
    `index` - the index of the cell.
  Returns:
    the value of the specified cell.
  Throws:
    `IndexOutOfBoundsException` - if `index<0 || index>=size()`.

### getNonZeros

    public void getNonZeros(IntArrayList indexList,
                            DoubleArrayList valueList)

  Fills the coordinates and values of cells having non-zero values into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists all have a new size, the number of non-zero values.

  In general, fill order is unspecified. This implementation fills like: `for (index = 0..size()-1) do ...` . However, subclasses are free to us any other order, even an order that may change over time as cell values are changed. (Of course, result lists indexes are guaranteed to correspond to the same cell).

  Example:

      0, 0, 8, 0, 7
      -->
      indexList  = (2,4)
      valueList  = (8,7)

  In other words, `get(2)==8, get(4)==7`.

  Parameters:
    `indexList` - the list to be filled with indexes, can have any size.
    `valueList` - the list to be filled with values, can have any size.

### getNonZeros

    public void getNonZeros(IntArrayList indexList,
                            DoubleArrayList valueList,
                            int maxCardinality)

  Fills the coordinates and values of cells having non-zero values into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists all have a new size, the number of non-zero values.

  In general, fill order is unspecified. This implementation fills like: `for (index = 0..size()-1) do ...` . However, subclasses are free to us any other order, even an order that may change over time as cell values are changed. (Of course, result lists indexes are guaranteed to correspond to the same cell).

  Example:

      0, 0, 8, 0, 7
      -->
      indexList  = (2,4)
      valueList  = (8,7)

  In other words, `get(2)==8, get(4)==7`.

  Parameters:
    `indexList` - the list to be filled with indexes, can have any size.
    `valueList` - the list to be filled with values, can have any size.

### getQuick

    public abstract double getQuick(int index)

  Returns the matrix cell value at coordinate `index`.

  Provided with invalid parameters this method may return invalid objects without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `index<0 || index>=size()`.

  Parameters:
    `index` - the index of the cell.
  Returns:
    the value of the specified cell.

### like

    public DoubleMatrix1D like()

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the same size. For example, if the receiver is an instance of type `DenseDoubleMatrix1D` the new matrix must also be of type `DenseDoubleMatrix1D`, if the receiver is an instance of type `SparseDoubleMatrix1D` the new matrix must also be of type `SparseDoubleMatrix1D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Returns:
    a new empty matrix of the same dynamic type.

### like

    public abstract DoubleMatrix1D like(int size)

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified size. For example, if the receiver is an instance of type `DenseDoubleMatrix1D` the new matrix must also be of type `DenseDoubleMatrix1D`, if the receiver is an instance of type `SparseDoubleMatrix1D` the new matrix must also be of type `SparseDoubleMatrix1D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Parameters:
    `size` - the number of cell the matrix shall have.
  Returns:
    a new empty matrix of the same dynamic type.

### like2D

    public abstract DoubleMatrix2D like2D(int rows,
                                          int columns)

  Construct and returns a new 2-d matrix of the corresponding dynamic type, entirelly independent of the receiver. For example, if the receiver is an instance of type `DenseDoubleMatrix1D` the new matrix must be of type `DenseDoubleMatrix2D`, if the receiver is an instance of type `SparseDoubleMatrix1D` the new matrix must be of type `SparseDoubleMatrix2D`, etc.

  Parameters:
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Returns:
    a new matrix of the corresponding dynamic type.

### set

    public void set(int index,
                    double value)

  Sets the matrix cell at coordinate `index` to the specified value.

  Parameters:
    `index` - the index of the cell.
    `value` - the value to be filled into the specified cell.
  Throws:
    `IndexOutOfBoundsException` - if `index<0 || index>=size()`.

### setQuick

    public abstract void setQuick(int index,
                                  double value)

  Sets the matrix cell at coordinate `index` to the specified value.

  Provided with invalid parameters this method may access illegal indexes without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `index<0 || index>=size()`.

  Parameters:
    `index` - the index of the cell.
    `value` - the value to be filled into the specified cell.

### swap

    public void swap(DoubleMatrix1D other)

  Swaps each element `this[i]` with `other[i]`.

  Throws:
    `IllegalArgumentException` - if `size() != other.size()`.

### toArray

    public double[] toArray()

  Constructs and returns a 1-dimensional array containing the cell values. The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa. The returned array `values` has the form
  `for (int i=0; i < size(); i++) values[i] = get(i);`

  Returns:
    an array filled with the values of the cells.

### toArray

    public void toArray(double[] values)

  Fills the cell values into the specified 1-dimensional array. The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa. After this call returns the array `values` has the form
  `for (int i=0; i < size(); i++) values[i] = get(i);`

  Throws:
    `IllegalArgumentException` - if `values.length < size()`.

### toString

    public String toString()

  Returns a string representation using default formatting.

  Overrides:
    `toString` in class `Object`
  See Also:
    `Formatter`

### viewFlip

    public DoubleMatrix1D viewFlip()

  Constructs and returns a new flip view. What used to be index `0` is now index `size()-1`, ..., what used to be index `size()-1` is now index `0`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Returns:
    a new flip view.

### viewPart

    public DoubleMatrix1D viewPart(int index,
                                   int width)

  Constructs and returns a new sub-range view that is a `width` sub matrix starting at `index`. Operations on the returned view can only be applied to the restricted range. Any attempt to access coordinates not contained in the view will throw an `IndexOutOfBoundsException`.

  Note that the view is really just a range restriction: The returned matrix is backed by this matrix, so changes in the returned matrix are reflected in this matrix, and vice-versa.

  The view contains the cells from `index..index+width-1`. and has `view.size() == width`. A view's legal coordinates are again zero based, as usual. In other words, legal coordinates of the view are `0 .. view.size()-1==width-1`. As usual, any attempt to access a cell at other coordinates will throw an `IndexOutOfBoundsException`.

  Parameters:
    `index` - The index of the first cell.
    `width` - The width of the range.
  Returns:
    the new view.
  Throws:
    `IndexOutOfBoundsException` - if `index<0 || width<0 || index+width>size()`.

### viewSelection

    public DoubleMatrix1D viewSelection(int[] indexes)

  Constructs and returns a new selection view that is a matrix holding the indicated cells. There holds `view.size() == indexes.length` and `view.get(i) == this.get(indexes[i])`. Indexes can occur multiple times and can be in arbitrary order.

  Example:

      this     = (0,0,8,0,7)
      indexes  = (0,2,4,2)
      -->
      view     = (0,8,7,8)

  Note that modifying `indexes` after this call has returned has no effect on the view. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Parameters:
    `indexes` - The indexes of the cells that shall be visible in the new view. To indicate that all cells shall be visible, simply set this parameter to `null`.
  Returns:
    the new view.
  Throws:
    `IndexOutOfBoundsException` - if `!(0 <= indexes[i] < size())` for any `i=0..indexes.length()-1`.

### viewSelection

    public DoubleMatrix1D viewSelection(DoubleProcedure condition)

  Constructs and returns a new selection view that is a matrix holding the cells matching the given condition. Applies the condition to each cell and takes only those cells where `condition.apply(get(i))` yields `true`.

  Example:

      // extract and view all cells with even value
      matrix = 0 1 2 3
      matrix.viewSelection(
         new DoubleProcedure() {
            public final boolean apply(double a) { return a % 2 == 0; }
         }
      );
      -->
      matrix ==  0 2

  For further examples, see the package doc. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Parameters:
    `condition` - The condition to be matched.
  Returns:
    the new view.

### viewSorted

    public DoubleMatrix1D viewSorted()

  Sorts the vector into ascending order, according to the natural ordering. This sort is guaranteed to be stable. For further information, see `Sorting.sort(DoubleMatrix1D)`. For more advanced sorting functionality, see `Sorting`.

  Returns:
    a new sorted vector (matrix) view.

### viewStrides

    public DoubleMatrix1D viewStrides(int stride)

  Constructs and returns a new stride view which is a sub matrix consisting of every i-th cell. More specifically, the view has size `this.size()/stride` holding cells `this.get(i*stride)` for all `i = 0..size()/stride - 1`.

  Parameters:
    `stride` - the step factor.
  Returns:
    the new view.
  Throws:
    `IndexOutOfBoundsException` - if `stride <= 0`.

### zDotProduct

    public double zDotProduct(DoubleMatrix1D y)

  Returns the dot product of two vectors x and y, which is `Sum(x[i]*y[i])`. Where `x == this`. Operates on cells at indexes `0 .. Math.min(size(),y.size())`.

  Parameters:
    `y` - the second vector.
  Returns:
    the sum of products.

### zDotProduct

    public double zDotProduct(DoubleMatrix1D y,
                              int from,
                              int length)

  Returns the dot product of two vectors x and y, which is `Sum(x[i]*y[i])`. Where `x == this`. Operates on cells at indexes `from .. Min(size(),y.size(),from+length)-1`.

  Parameters:
    `y` - the second vector.
    `from` - the first index to be considered.
    `length` - the number of cells to be considered.
  Returns:
    the sum of products; zero if `from<0 || length<0`.

### zDotProduct

    public double zDotProduct(DoubleMatrix1D y,
                              int from,
                              int length,
                              IntArrayList nonZeroIndexes)

  Returns the dot product of two vectors x and y, which is `Sum(x[i]*y[i])`. Where `x == this`.

  Parameters:
    `y` - the second vector.
    `nonZeroIndexes` - the indexes of cells in `y`having a non-zero value.
  Returns:
    the sum of products.

### zSum

    public double zSum()

  Returns the sum of all cells; `Sum( x[i] )`.

  Returns:
    the sum.

Colt 1.2.0

Jump to the Colt Homepage